diff -Nur openbsc.noapp_2009_05_31/src/e1_input.c openbsc.new_2009_05_31/src/e1_input.c
--- openbsc.noapp_2009_05_31/src/e1_input.c	2009-06-01 11:26:54.000000000 +0200
+++ openbsc.new_2009_05_31/src/e1_input.c	2009-06-03 18:16:31.000000000 +0200
@@ -133,6 +133,7 @@
 	int ret;
 	time_t cur_time;
 	struct tm *tm;
+	int mi_head = (direction==PCAP_INPUT) ? MISDN_HEADER_LEN : 0; 
 
 	struct fake_linux_lapd_header header = {
 		.pkttype	= 4,
@@ -156,10 +157,10 @@
 		.ts_usec    = 0,
 		.incl_len   = msg->len + sizeof(struct fake_linux_lapd_header)
 				+ sizeof(struct lapd_header)
-				- MISDN_HEADER_LEN,
+				- mi_head,
 		.orig_len   = msg->len + sizeof(struct fake_linux_lapd_header)
 				+ sizeof(struct lapd_header)
-				- MISDN_HEADER_LEN,
+				- mi_head,
 	};
 
 
@@ -170,8 +171,8 @@
 	ret = write(pcap_fd, &payload_header, sizeof(payload_header));
 	ret = write(pcap_fd, &header, sizeof(header));
 	ret = write(pcap_fd, &lapd_header, sizeof(lapd_header));
-	ret = write(pcap_fd, msg->data + MISDN_HEADER_LEN,
-			msg->len - MISDN_HEADER_LEN);
+	ret = write(pcap_fd, msg->data + mi_head,
+			msg->len - mi_head);
 }
 
 static const char *sign_types[] = {
